#include "TestProgramV2_1_1.h"
//#include "GMT_BriEye.h"
//#include "AutoOpticsTest.h"

//float X,Y,Z;
#define uart_interrupt_enable()  {ES0=1;}
#define uart_interrupt_disable() {ES0=0;}
void uart_init( void )
{  
	// initialize serial port registers	
	S0CON = 0x72;  //Mode1, 8bit uart
	PCON = 0x80;   //SMOD0=0;

	// Use Timer 1
	TMOD    = 0x20;		// Timer 1 in mode 2, 8-bit auto-reload 
	TR1     = 1;		// Turn on Timer 1 
	TL1 = TH1 = 0xff;	// Set reload value 
	//uart_interrupt_disable();
	ES0=0;
}


void uart_putchar( unsigned char ch )
{  
 //	int i;
	if(TI) TI=0; 
	S0BUF = ch;
	while(!TI);	 
	TI=0;		
}

unsigned char uart_getchar( void )
{
	unsigned char d;
	
	while(!RI);	
	d=S0BUF;  
	RI=0;	  
	return d; 
}

/*
char uart_putstr_1( void )
{
	char d;
	return d; 
}
*/
/*
int uart_putstr(unsigned char xdat *data_temp1,int len) 
{
//   unsigned char data_temp2[11];
   int i;

  for(i=0;i<11;i++)
  {
    uart_putchar(data_temp1[i]);
  }
} 
*/
/*
 * return:
 *   0 -- error
 *  !0 -- flick value
 */

float read_flick(void)		 //32-bit
{
	unsigned char i;
	unsigned char *pbuf;
	unsigned char cmd[12]= ":*amt?flick#";
	float flick=0.0;

	uart_init();
	for(i=0;i<12;i++)
		uart_putchar(cmd[i]);
	pbuf=(unsigned char *)&flick;
	if(0x30 != uart_getchar())
	{
		//Display_Message("flick Error");
		Wait_Halt(500);
		Start_Button(1); 
	}
	else
	{
//		for(i=0;i<4;i++)
        for(i=4;i>0;i--)   //BriEye dataӸλλ.

		{
		   //	*(pbuf+i)=uart_getchar(); 
		   *(pbuf+i-1)=uart_getchar();    
		}
	}
	return flick;
}


/*
 * return:
 *   0 --- error
 *   1 --- OK
 */
unsigned char read_rgb(float rgb[3])
{
	unsigned char i;
	unsigned char *pbuf;
	unsigned char cmd[11]= ":*amt?rgb#7";
 
	uart_init();
	for(i=0;i<11;i++)
		uart_putchar(cmd[i]);
	
	if(0xE0 != uart_getchar())
	{
		//Display_Message("flick Error");
		Wait_Halt(500);
		Start_Button(1); 
		return 0;
	}
	else
	{	
		pbuf=(unsigned char *)rgb;
		for(i=0;i<12;i++)  //BriEye dataӵλλ.

		{
			*(pbuf+i)=uart_getchar();   
		}
		return 1;
	}
}
unsigned char read_rgb2(float *x,float *y,float *z)
{
	float rgb[3];
	if(0==read_rgb(rgb))
	{
		*x=0;
		*y=0;
		*z=0;
		return 0;
	}
	else
	{
		*x=rgb[0];
		*y=rgb[1];
		*z=rgb[2];
		return 1;
	}
}
/*
 int OpticsTest(void)
{ 
	unsigned char *pbuf;
 //	int i,len=11;
	unsigned char i;
	int k,k1;
// 	unsigned char data_temp[2][11]={
// 	":*amt?rgb#7",
// 	"*gmt#red"
// 	};
  unsigned char data_temp[11]= ":*amt?rgb#7";	

//	":*amt?rgb#7";	
	double rgb_value[3];
//  unsigned char data[]=":*amt?rgb#7";
//    int X,Y,Z;
//     volatile float X,Y,Z;
//	Globe_Error=0;
	   pbuf=(unsigned char *)rgb_value;	
  	   uart_init(); //init brieye
	   //uart_putchar(0xE7);
 //	    Wait(200);
 //	    uart_init();
  //	    Wait(100);
  for(i=0;i<11;i++)
  {
   // uart_putchar(data_temp[0][i]);
     uart_putchar(data_temp[i]);
  }
 //    Wait(50);
//     uart_putstr_1();//?11???
//     uart_putstr(":*amt?rgb#7",11);//?11???
//	   se_putchar(0xE7);
//      drvUARTSend(":*amt?rgb#7",11);
//	   Display_Message("begin rev");
 	
	   k1=uart_getchar();  //read brieye feedback value
//	   Display_Integer("k1=%x",k1);
//	   Wait_Halt(1000);	   
	   if(k1!=0xE0)	   //
	   {
			Display_Message("Error");
			Wait_Halt(500);
	 		 Start_Button(1); 
	   }
	   for(k=0;k<12;k++)  //read X,Y,Z, X = 0 to 3,Y = 4 to 7,Z = 8 to 11
	   {
	  //	   Display_Integer("k=%d",k);
  	   	   *(pbuf+k)=uart_getchar();   
  	   	   //		   Display_Integer("k1=%x",*(pbuf+k));
	   } 
//	   Display_Integer("k=%d",k);
	    //rgb_value[1]=0.12345;
	   //	rgb_value[2]=255.12345;
	 		 X = rgb_value[0];
			 Y = rgb_value[1];
			 Z = rgb_value[2];
//    	Test_Float("value0= \n%f",rgb_value[0],-3.0,700);
//		Wait_Halt(4000);
//		Test_Float("value1= \n%f",rgb_value[1],-3.0,700);
//		Wait_Halt(4000);
//		Test_Float("value2= \n%f",rgb_value[2],-3,700);
//		Wait_Halt(4000);
	 	lt(100);
 	   if(Test_Float("R_Y= %f",R_Y,0,620))
		   {Display_Message("R_Y out of limit");
				ErrorPanLed(1);
			  //	Globe_Error=1;
			  //	if (Test_Error) goto end;
				Wait(300);
		   }

	     return 0;
  }					  */

